void _tp_dict_tp_realloc(_tp_dict *self,int len) {
    int i;
    if (!len) { len=1; }
    self->items = tp_realloc(self->items,len*sizeof(tp_item));
    for (i=self->alloc; i<len; i++) {
        self->items[i] = (tp_item){0,0};
    }
    self->alloc = len;
}
int _tp_dict_cmp(tp_item *a,tp_item *b) {
    return strcmp(a->key,b->key);
}

int _tp_dict_find(_tp_dict *self,char *k) {
    tp_item key = (tp_item){k,0};
    tp_item *e = bsearch (&key, self->items, self->length, sizeof(tp_item), (int(*)(const void*,const void*)) _tp_dict_cmp);
    if (e) { return (int)(e-self->items); } // HACK: scary pointer math!
    return -1;
}

void _tp_dict_set(_tp_dict *self,char *k, void *v) {
    int n = _tp_dict_find(self,k);
    if (n == -1) {
        n = self->length;
        if (self->length >= self->alloc) {
            _tp_dict_tp_realloc(self,self->alloc*2);
        }
        self->length += 1;
        self->items[n] = (tp_item){k,v};
        qsort(self->items, self->length, sizeof(tp_item), (int(*)(const void*,const void*))_tp_dict_cmp);
    } else {
        self->items[n] = (tp_item){k,v};
    }
}

void *_tp_dict_get(_tp_dict *self,char *k, char *error) {
    int n = _tp_dict_find(self,k);
    if (n < 0) {
        if (error) { vm_raise("%s: KeyError: %s\n",error,k); }
        return 0;
    }
    return self->items[n].value;
}

void *_tp_dict_del(_tp_dict *self,char *k, char *error) {
    int n = _tp_dict_find(self,k);
    if (n < 0) {
        if (error) { vm_raise("%s: KeyError: %s\n",error,k); }
        return 0;
    }
    memmove(&self->items[n],&self->items[n+1],sizeof(tp_item)*(self->length-(n+1)));
    self->length -= 1;
}

_tp_dict *_tp_dict_new(int len) {
    _tp_dict *self = tp_malloc(sizeof(_tp_dict));
    self->items = 0;
    self->length = 0;
    self->alloc = 0;
    _tp_dict_tp_realloc(self,len);
    return self;
}
_tp_dict *_tp_dict_copy(_tp_dict *o) {
    _tp_dict *r = _tp_dict_new(o->alloc);
    memcpy(r->items,o->items,sizeof(tp_item)*o->alloc);
    r->length = o->length;
    return r;
}

tp_obj merge(tp_obj params) {
    P_BEGIN(params);
    tp_obj self = P_OBJ("self");
    tp_obj v = P_OBJ("value");
    P_END;
    int i;
    for (i=0; i<v.dict.value->length; i++) {
        _tp_dict_set(self.dict.value,v.dict.value->items[i].key,v.dict.value->items[i].value);
    }
    return None;
}

tp_obj tp_dict(int len,tp_obj argv[]) {
    int i;
    tp_obj r;
    r.type = TP_DICT;
    r.dict.value = _tp_dict_new(len);
    for (i=0; i<len; i+=2) {
        tp_obj k = argv[i];
        tp_obj v = argv[i+1];
        tp_set(r,k,v);
    }
    return r;
}

#define rot(x,k) (((x)<<(k)) | ((x)>>(32-(k))))
#define mix(a,b,c) { \
    a -= c;  a ^= rot(c, 4);  c += b; \
    b -= a;  b ^= rot(a, 6);  a += c; \
    c -= b;  c ^= rot(b, 8);  b += a; \
    a -= c;  a ^= rot(c,16);  c += b; \
    b -= a;  b ^= rot(a,19);  a += c; \
    c -= b;  c ^= rot(b, 4);  b += a; \
}
#define final(a,b,c) { \
    c ^= b; c -= rot(b,14); \
    a ^= c; a -= rot(c,11); \
    b ^= a; b -= rot(a,25); \
    c ^= b; c -= rot(b,16); \
    a ^= c; a -= rot(c,4);  \
    b ^= a; b -= rot(a,14); \
    c ^= b; c -= rot(b,24); \
}

uint32_t hashword(const uint32_t *k,size_t length,uint32_t initval) {
    uint32_t a,b,c;
    a = b = c = 0xdeadbeef + (((uint32_t)length)<<2) + initval;
    while (length > 3) {
        a += k[0]; b += k[1]; c += k[2];
        mix(a,b,c);
        length -= 3; k += 3;
    }
    switch(length) {
        case 3: c+=k[2];
        case 2: b+=k[1];
        case 1: a+=k[0]; final(a,b,c);
    }
    return c;
}



